Copyright: CD Player écrit par Jean-Denis MUNOS


Index

Merci d'utiliser CD Player 1.0 !

Je vous rappelle que CD Player est un Free Ware.

CD Player a été écrit en Borland Pascal 7.0 en utilisant la bibliothèque Object Windows, et est écrit totalement en orienté objet. Les sources (commentés) sont disponibles moyennant la modique somme de 50 Francs, si vous en faites la demande à :

 	                          Mr Jean-Denis MUNOS

                          5, Rue du Capitaine Fonck

                          78140 VELIZY-VILLACOUBLAY.

N'oubliez pas d'indiquer le format souhaité (5 1/4 ou 3 1/2), ainsi que la densité.

N'oubliez pas d'indiquer vos coordonnées : les demandes incomplètes ne pourront être traitées !!

-Présentation générale

-Modes de lecture

-Modes d'affichage

-Pistes favorites

-Nouveau CD

-Description de la Face Avant

-Recherche de CD

-Options de configuration

-Remerciements

-Autres produits de l'auteur


Free Ware

Un logiciel en Freeware est un logiciel dont l'utilisation est gratuite.

Ce mode de diffusion, en plein essor, permet d'obtenir des logiciels de bonne qualité, pour un prix nul. Toutefois, ces logiciels ont demandé pas mal d'effort à leur concepteur, et un petit mot, une carte postale, ou un don n'a jamais été refusé !

Vous êtes encouragés à diffuser cette version de CD Player auprès de vos amis et connaissances. Les administrateurs de BBS, quant à eux, doivent me demander une autorisation écrite avant de mettre cette version de CDPlayer sur leurs BBS, disques ou disquettes. Cette autorisation n'est qu'une formalité, et sera accordée systématiquement. Une éventuelle mise à jour leur sera envoyée à cette occasion.


Présentation générale

CD Player est un logiciel permettant de jouer ses CD sur un lecteur CD ROM correctement installé sur l'ordinateur.

Il dispose des fonctions de lecteurs CD 'haut de gamme', à savoir, la possibilité de rentrer le nom des pistes, ainsi que la possibilité de personnaliser le mode de lecture.

En outre, il est possible de faire un certain nombre de recherches sur les disques entrés, et permet donc de tenir à jour une base de CD, et gère aussi l'édition de jacquettes de cassettes sur votre imprimante ! Cliquez sur le bouton Aperçu pour voir ce que cela donne sur l'imprimante !


Modes de Lecture

CD Player dispose de plusieurs modes de lecture :

Mode normal : Les pistes sont jouées dans l'ordre croissant, de la piste courante jusqu'à la fin du CD.

Mode Pistes Favorites : Les pistes sont jouées dans l'ordre sélectionné. Le bouton 'Pistes Favorites' de la boite de dialogue principale permet de définir l'ordre de lecture. Vous pouvez faire jouer plusieurs fois la même piste.

Mode 'Shuffle' : Les pistes sont lues dans l'ordre aléatoire, une fois et une seule jusqu'à la fin du disque.

Mode 'Shuffle et Favorites' : Une sorte de remix des deux modes précédents : Il permet de lire dans l'ordre aléatoire les pistes préférées. C'est cette option que je trouve primordiale, et qui m'a amené à écrire CD Player. En effet, je ne l'ai rencontrée sur aucun autre programme.


Mode Affichages

CD Player dispose de plusieurs modes d'affichage, comme les lecteurs de salon. Il permet de voir le temps écoulé depuis le début de la piste, le temps restant pour la piste courante, ainsi que les pistes écoulées ou les pistes restantes.

La sélection se fait en cliquant sur le bouton 'Affichage' [image] du panneau principal. La sélection se fait comme suit :

Mode d'affichage par défaut :	   	   	   Temps écoulé, Pistes jouées

Une pression sur bouton affichage :	   	   Temps restant, Pistes jouées

Une autre pression :	   	   	   	   Temps écoulé, Pistes restantes

Une autre pression :	   	   	   	   Temps restant, Pistes restantes

Une autre pression : 	   	   	   	   Temps écoulé, Pistes jouées.

Ces modes de lecture sont symbolisés par un code de couleur au niveau de l'afficheur principal de CD Player. Le point rouge indiquant le mode d'affichage courant.


Boites de dialogues

Plusieurs commandes de menu auront pour conséquence d'afficher une boite de dialogue à l'écran. Parmi celles-ci, on trouve :

-Nouveau CD

-Recherche Titre

-Durée d'enregistrement

-Impression jacquettes

-Exporter base

-Options!


Nouveau CD

La boite de dialogue Nouveau CD apparait lorsque vous avez sélectionné la commande Disque/Nouveau CD, ou lorsque vous lancez CD Player, alors qu'aucun CD n'est dans le lecteur. Elle permet de réinitialiser CD Player lorsqu'un nouveau CD est introduit dans le lecteur.

Prenez garde : Certains lecteurs sont relativement lents, et il peut être nécessaire d'attendre plusieurs secondes entre l'insertion d'un nouveau CD, et sa lecture effective par Windows. Soyez donc un petit peu patient lorsque vous insérez un nouveau CD.

Si malgré une attente raisonnable, ou si vous venez de lancer CD Player, et que cette boite de dialogue apparaît alors que vous êtes sûr qu'un CD est bien inséré dans le lecteur, il est probable que votre gestionnaire CD Audio de Windows soit mal installé. Vérifiez-le dans l'icone Configuration du Gestionnaire de Programme. Vous devriez voir l'option [MCI CD Audio]. Si ce n'est pas le cas, consultez le guide d'installation de Windows.


Pistes Favorites

Les pistes favorites vous permettent en fait de décider de l'ordre dans lequel sera joué un ensemble de pistes. Cette option vous permet aussi de demander à CD Player de ne jamais jouer certaines pistes. Plusieurs modes de lecture sont possibles.

Il est tout à fait possible de faire jouer une piste plusieurs fois dans ce mode de programmation.


Recherche Titre

Cette boite de dialogue permet de rechercher un titre parmi tous les CD enregistrés. Entrez simplement une partie du titre à chercher, CD Player recherchera la chaine demandée dans tous les titres de tous les CD. La recherche n'est pas sensible aux majuscules/minuscules.

Limites : Si vous avez deux titres qui contiennent le mot que vous recherchez, CD Player se positionnera sur la dernière occurrence.

Le bouton [image] vous permet de chercher la prochaine occurrence de la chaine demandée dans le prochain CD, et non pas la prochaine occurrence dans le disque courant !


Description de la Face Avant

La face avant de CD Player se compose de plusieurs éléments :

-Les boutons de commande

-Les zones d'affichage

-Le menu

-Vous pouvez aussi consulter l' Index général de l'aide

Conseils pratiques :

Utilisez souvent l'aide contextuelle : certaines boites de dialogue recèlent d'options non visibles, comme le click droit souris. Chaque fois que possible l'écran d'aide vous donnera toutes les options possibles, ainsi que des conseils pour mieux utiliser CD Player.

Sur l'écran principal, vous pouvez utiliser le click droit souris pour avoir la description de l'objet sur lequel vous avez cliqué.


Description des boutons de la face avant

Cette touche appelle la boite de dialogue qui permet d'affecter un nom à une piste du CD. Vous aurez la possibilité d'enregistrer votre travail, qui sera ainsi fait une fois pour toutes.

Cette touche permet de se positionner rapidement sur une piste. Si le CD est enregistré dans la base de données, au lieu du numéro de piste, vous pourrez voir son nom.

Cette touche permet de définir un mode de programmation pour le CD courant, et de l'enregistrer pour éviter, plus tard, de repréciser le mode de programmation.

Cette touche permet de passer successivement dans l'un des 4 modes d'affichage de CD Player.

Cette touche permet de définir un mode de lecture différent pour le CD courant. Ainsi, si vous avez enregistré un CD avec mode de lecture aléatoire, vous pouvez définir une programmation, et l'appui sur cette touche vous permettra d'annuler le mode aléatoire afin de revenir au mode programmé. Les modifications ne seront pas enregistrées, à moins que vous le demandiez.

 et [image] Ces boutons permettent, comme le précédent, de définir un mode de lecture temporaire pour le CD.

Ce n'est pas à proprement parler un bouton, mais plutôt un indicateur qui permet de se repérer dans les modes d'affichage de CDPlayer.

Ce bouton permet d'appeler un outil (un .EXE) directement depuis CDPlayer. Par défaut, il est configuré pour appeler la table de mixage de la Sound Blaster, mais il faut que vous indiquiez le chemin complet pour accéder à ce fichier.

Les autres boutons sont communs à tous les lecteurs CD et sont :

Lecture/Pause, Arrêt, Piste Suivante, Piste Précédente, Avance Rapide (20 secondes, par défaut) et Retour Rapide.


Zone d'Affichage

CD Player dispose de plusieurs zones d'affichage.

Cette zone affiche les pistes écoutées ou restantes, suivant le mode d'affichage courant. Le symbole + est affiché lorsque le CD comporte plus de 14 pistes

Cette zone d'affichage indique, suivant le mode d'affichage courant, soit le temps écoulé depuis le début de la piste, soit le temps restant pour la piste. Le format est toujours sous la forme PP:MM:SS où PP est le numéro de la piste, MM représente un temps en minutes, et SS, en secondes. Si le CD est arrêté, il indique la durée (en minutes:secondes:centièmes)

Cette zone affiche le nom des pistes lorsque le CD est en train de jouer, ou le titre de l'album si le CD est arrêté.

Ceci est un indicateur du mode d'affichage courant. Le point rouge, indiquant le mode courant, se déplace à chaque appui sur la touche

La barre de titre de la fenêtre affichant, quant à elle, le nom de l'interprète.


Temps d'enregistrement

Cette boite de dialogue vous permet, lorsque vous avez un CD, de définir une durée de K7 (par exemple, 45 minutes). CD Player va alors automatiquement choisir quelles sont les pistes qui permettent de remplir au mieux le temps entré. Pour cela, choisissez un CD parmi la liste des CD (double-clickez dessus, ou appuyez sur le bouton Contenu) : la liste des chansons du CD apparait alors dans la liste du bas, pour vérification.

Si vous avez indiqué un mode de programmation pour votre CD, vous pouvez cocher la case 'Utiliser préférences' pour indiquer à CD Player de se baser sur votre programmation. Il cherchera alors le meilleur temps en se basant sur vos préférences !!!

Les performances de l'algorithme de recherche sont nulles (ce n'était pas le but initial du projet). Suivant les demandes, j'implémenterai un algorithme avec recherche optimisée. N'hésitez pas à me contacter ! Cliquez ici pour voir mes coordonnées ...


Impression de Jacquettes

Cette boite de dialogue vous permet de gérer l'impression de vos jacquettes.

Elle dispose de plusieurs champs :

Contenu du CD : Affiche le contenu du CD sélectionné.

Titre Face A / B : Vous permet de rentrer un titre qui viendra s'imprimer sur la tranche de la jacquette, ainsi qu'en entête de chaque face du CD. Si vous entrez le titre seul, il sera centré dans la zone du titre (la tranche de la jacquette). Par contre, si vous entrez la chaine sous la forme Auteur / Titre, vous aurez 2 chaines sur la tranche. La première sera l' Auteur sur la première ligne, et la deuxième sera le Titre juste en dessous. Vous pouvez cliquer sur aperçu pour voir les différences.

Piste A / Piste B : Zones réservées aux noms de pistes qui viendront s'imprimer sur la jacquette.

Entrée Libre : Cette zone vous permet de rentrer une chaine particulière, ou un commentaire, dans l'espace réservé aux titres de la piste A ou de la piste B.

Numéro K7 : Cette zone vous permet de saisir le numéro de la cassette. Ce nombre de 2 chiffres maximum viendra s'inscrire sur la partie centrale de la tranche de la jacquette. Si le numéro n'a qu'un seul chiffre, un 0 (zéro) est automatiquement inséré devant.

Bouton 'Retirer' : supprime la ou les pistes sélectionnées dans la zone Piste A ou Piste B.

Pour faire 'passer' une piste de la zone contenu à la zone Piste A, vous pouvez soit la sélectionner, et appuyer sur le bouton 'Ajouter A', soit double-cliquer dans la zone contenu.

Pour faire passer une piste de la zone contenu à la zone Piste B, vous pouvez soit la sélectionner, et appuyer sur le bouton 'Ajouter B', soit la sélectionner avec le bouton gauche et double-cliquer avec le bouton droit de la souris.


Edition de Piste

Cette boite dialogue permet de rentrer les noms des pistes du CD Audio.

Vous disposez, sur la gauche, du numéro de la piste en regard de laquelle vous avez une place pour y rentrer son nom, ainsi que deux boutons sur la droite permettant de monter ou de descendre d'une ligne,mais le scrolling est géré de manière automatique.

Le bouton 'Enregistrer' permet de sauvegarder sur disque les informations entrées.

Limites : Le bouton annuler ne permet pas d'annuler les informations entrées, mais sert seulement à refermer la boite de dialogue.

Remarque : Afin de faciliter la saisie, le scrolling est géré de manière automatique. Mais il y a le revers de la médaille ! Si vous souhaitez enregistrer votre saisie en plein milieu du travail, et si votre curseur se trouve sur la dernière zone de saisie, vous allez 'scroller' au lieu d'enregistrer votre travail. La parade, pour désactiver le scrolling automatique est de positionner le curseur d'abord sur un champ de saisie (n'importe lequel, mais pas le premier, ni le dernier), et ensuite cliquer sur enregistrer.


Programmation CD Player

Cette boite de dialogue permet de définir l'ordre dans lequel seront lues les pistes du CD Audio. CD Player dispose de quatre modes de lectures.

Pour définir une programmation, sélectionnez une piste et cliquez sur 'Ajouter'. Elle viendra s'ajouter à la liste 'Programme' de droite. Si vous double-cliquez sur la piste, vous pourrez l'écouter (c'est pratique dans le cas où vous auriez oublié de rentrer le nom de la piste ....).

Pour retirer une piste, sélectionnez-là dans la liste de droite, et cliquez sur 'Retirer'.

Le bouton 'Tout' permet d'ajouter toutes les pistes de la liste 'Contenu' à la liste 'Programme', et le bouton 'Vider' retire toutes les listes de la programmation. Attention : ce bouton ne permet pas d'ajouter les pistes restantes, mais ajoute vraiment tout le contenu du CD !

Vous avez ensuite la possibilité de définir un mode de lecture particulier pour ce CD.

Le bouton [image] vous permet de sauvegarder les informations dans le fichier.


L'appui sur la touche Imprimer de la fenêtre Aperçu avant Impression va provoquer une impression ressemblant à ceci sur votre imprimante.


Positionnement Piste

Cette boite de dialogue vous permet de vous positionner rapidement sur une piste. Si le CD est enregistré, CD Player vous indiquera le nom de la piste. Dans le cas contraire, il indiquera son numéro et sa durée.

Vous pouvez double-cliquer sur le nom d'une piste, plutôt que la sélectionner puis valider.


Choix CD

Cette boite de dialogue affiche tous les CD enregistrés dans la base de données sous la forme : Auteur / Titre CD. Pour sélectionner un CD particulier, vous pouvez double-cliquer sur son nom, ou le sélectionner, et valider.

Cette boite de dialogue est appelée lorsque vous voulez imprimer une jacquette pour cassette audio.


A propos de CD Player

Ceci est la boite de dialogue rituelle pour tout programme Windows digne de ce nom. Vous pourrez trouver une petite surprise lors de la fermeture de la boite de dialogue dans le cas de l'utilisation de la souris. Pour la refermer, il faut faire ******* (texte illisible).

Après tout, pourquoi vous le dirais-je ?, c'est très simple à fermer, une boite de dialogue ...


Installation de CD Player

Dans le cas où CD Player n'est pas installé sur votre machine, CD Player lance automatiquement sa procédure d'installation.

L'installation recopie les fichiers Install.exe (qui est renommé en Cdplayer.exe), Cdplayer.hlp et Bwcc.dll dans les répertoires sélectionnés.

Ni le WIN.INI, ni tout autre fichier .INI n'est modifié;  aucune DLL n'est copiée dans Windows, Windows/System, ou dans un répertoire autre que celui spécifié à l'installation, à l'exception de la DLL CTL3DV2.DLL (Je tiens par la présente à remercier (Tm) Microsoft qui oblige à faire ainsi, et qui semble oublier que si Windows lui appartient, il n'en est pas de même avec le répertoire de mon disque dur. En effet, en se cassant la tête pendant environ 1/3 secondes, il aurait pû trouver le moyen de faire autrement -Borland l'ayant déjà fait avec leur BWCC !-).


Liste des options du menu

Plusieurs commandes sont disponibles depuis le menu principal :

-Nouveau CD

-Rechercher Titre

-Durée d'enregistrement

-Imprimer Jacquette

-Exporter Base

-Options!

-Index

-A Propos de ...


Remerciements

Je tiens à remercier les personnes (et objets) suivants :

* Eric MINET, pour ses béta-tests, et ses conseils précieux pour l'amélioration de l'interface de CD Player (il faudra quand même que je lui dise de se calmer avec ses suggestions, et de ne pas s'attendre à ce que je rajoute une feature qui fasse le café ...) (Ceci étant dit, il a quand même été un allié de poids, me remettant sans cesse en question).

* Mon cousin, Xavier POWAGA, qui a aussi participé au béta test du programme, mais qui a oublié de me faire part de toutes ses critiques. (Quel étourdi !) (J'en profite pour embrasser mes petites cousines Christelle et Emilie, et leur maman Sylvie).

* Jean-Jacques ETOTOUE, et particulièrement sa moitié, Mado, qui a failli traduire ce fichier d'aide en anglais (afin que le monde entier puisse profiter de ce programme), mais qui a renoncé quand elle a vu sa taille. (ne rigolez pas, c'est du boulot)

* Mon ordinateur préféré (il s'appelle 486DX33), qui a rebooté un minimum de fois lors de la mise au point du programme. (Brave bête !).


Autres produits

L'auteur de CD Player n'en est pas à son coup d'essai. Il est même connu comme un récidiviste !

Parmi ses forfaits, on compte :

PLAYER 1.01 : Un programme sous DOS, qui utilise l'interface Turbo Vision de Borland, et qui permet de jouer toutes sortes de fichiers musicaux, indépendemment de leur type (MOD, MID, CMF, et autres CMS). Le principe est simple : on associe une fois pour toutes une extension de fichier avec un 'player' (par exemple, PLAYCMF.EXE pour les fichiers .CMF). Accessoirement, vous pouvez définir un 'loader' (dans notre exemple, SBFMDRV.COM), ainsi qu'un switch pour désinstaller le 'loader' (/U le plus souvent). Une fois cette manipulation faite, lorsque vous lancez PLAYER, il vous affiche la liste des fichiers dont il connait l'extension. Vous pouvez alors définir une liste de fichier à jouer, et PLAYER se charge de vous les jouer dans le bon ordre, de charger éventuellement les résidents, et de les décharger même de la mémoire !

De plus, PLAYER peut décompacter tout seul les fichiers musicaux présents dans les .ZIP, même au format 2.04 !!

Lieu de rencontre fréquent de PLAYER : Compuserve, DP TOOL, ou chez l'auteur contre une enveloppe pré-affranchie et une disquette formattée.

CD Player 1.00 : Ce programme même.

Lieu de rencontre fréquent de CD Player : Compuserve, peut être DP TOOL, ou chez l'auteur (mêmes conditions que plus haut).

Z 1.00 : Un utilitaire en ligne de commande afin de rendre compatible au niveau des options de ligne de commande tous les compacteurs et décompacteurs connus et inconnus à ce jour. Car qui peut se souvenir de l'option pour faire un fichier EXE auto-extractible avec PKZIP, ARJ et LHA sans tricher ?? Avec Z, tout devient simple, vous pouvez le configurer pour qu'il utilise la syntaxe de votre compresseur préféré. Par exemple, si vous aimez ARJ, vous savez qu'on doit utiliser -je pour créer un fichier auto-extractible. Mais cette manipulation avec ZIP nécessite deux étapes : le PKZIP lui même, et le ZIP2EXE. Grâce à Z, vous pouvez décider que l'option -je servira à PKZIP à créer un fichier EXE. Vous lancez Z ZIP -je TOTO *.*. Z se chargera tout seul de lancer PKZIP avec les bonnes options, puis ZIP2EXE éventuellement. Tout ceci est entièrement configurable, grâce à un fichier de configuration, disposant même de macros !

Z a été vu pour la dernière fois sur Compuserve, ou auprès de l'auteur (mêmes conditions).


Exportation de la base

Cette option de menu sert à exporter les données du fichier DATABASE.CD au format ASCII délimité. Le fichier créé peut donc être ensuite repris par tout tableur ou base de données.

La structure du fichier produit étant :

"Auteur","Titre CD","Titre 1","Durée"

Ces lignes étant répétées pour chaque titre du CD, et pour chaque CD.


Options de configuration

Cette boite de dialogue permet de configurer un certain nombre d'options de CD Player :

-L'option Minimiser au démarrage permet de mettre CD Player en icône automatiquement la première fois qu'il est lancé. Vous pouvez ainsi le mettre dans le groupe Démarrage de Windows.

-L'option Démarrer Lecture Automatiquement a pour but de positionner CD Player en mode lecture si un disque se trouve dans le lecteur. Si vous l'activez en même temps que Minimiser au démarrage, vous pourrez démarrer CD Player automatiquement, et le mettre en icône au chargement !

-L'option Toujours Visible permet de mettre CD Player en avant plan, quelle que soit l'application active.

-Vous pouvez aussi modifier la Couleur de l'Afficheur de CD Player, et choisir parmi les couleur proposées dans le boite liste.

-L'Incrément Déplacement Rapide détermine le nombre de secondes que CD Player sautera en avant, ou en arrière, en cas d'appui sur une des touches de déplacement rapide.

-L'option Outil permet de choisir un outil qui sera appelé à partir du bouton [image] de l'écran principal. Vous pouvez cliquer sur le symbole [image] pour choisir rapidement dans une liste l'exe choisi.

Vous pouvez sauvegarder ces options en cliquant sur le bouton [image]. Les informations seront enregistrées dans le .INI, et seront valides dès maintenant, et pour les prochaines sessions de Windows.